;=======================================================================================
;Enable/Reable ReSharper Intellisense AHK Script
;
;Description:
;  Enables or disables the resharper option of intellisense.
;  Toggle between resharper and Visual Studio intellisense with Ctrl + Shift + 7.
;=======================================================================================

;==========================
;Initialise
;==========================
#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.


EnabledIcon := "spark.ico"
DisabledIcon := "sparksleep.ico"
IsInSparkMode := false

; Start off in the off mode (to update the icon)
SetIcon(false)

;==========================
;Toggle Switch
;==========================
^+7::
  ToggleOptions(!IsInSparkMode)
return

;==========================
;Functions
;==========================

ToggleOptions(toActive) {

	Send, {ALTDOWN}r{ALTUP}o
	
	WinWait, ReSharper  Options, ,2
	if ErrorLevel
	{
		return
	}

	IfWinNotActive, ReSharper  Options, , WinActivate, ReSharper  Options, ,2
	if ErrorLevel
	{
		return
	}
	
	WinWaitActive, ReSharper  Options, ,2
	if ErrorLevel
	{
		return
	}
	
	SetIcon(toActive)
	Send, {TAB}{DOWN}{ENTER}
}

SetIcon(toActive) {
  local iconFile := toActive ? EnabledIcon : DisabledIcon
  local state := toActive ? "ON" : "OFF"
  
  IsInSparkMode := toActive
  Menu, Tray, Tip, Spark mode is %state%  
  Menu, Tray, Icon, %iconFile%,  
}